#' Non-business days in Brazil from 1946-01-01 to 2299-12-31.
#'
#' This data frame contains all Saturdays and Sundays and the following
#' Brazilian national holidays:
#' \itemize{
#'   \item New Year's Day (always on 01. Jan)
#'   \item Shrove Monday (variable date)
#'   \item Shrove Tuesday (variable date)
#'   \item Good Friday (variable date)
#'   \item Tiradentes' Day (always on 21. Apr)
#'   \item Labour Day (always on 01. May)
#'   \item Corpus Christi (variable date)
#'   \item Independence Day (always on 07. Sep)
#'   \item Our Lady of Aparecida (always on 12. Oct)
#'   \item All Souls' Day (always on 02. Nov)
#'   \item Republic Day (always on 15. Nov)
#'   \item Christmas Day (always on 25. Dec)
#' }
#'
#' @docType data
#'
#' @usage data(NonBusDays.Brazil)
#'
#' @format A data frame with 40378 rows and 3 variables:
#' \itemize{
#'   \item{Holiday.Name}
#'   \item{Date}
#'   \item{Weekday}
#' }
#'
#' @references
#' Itau Unibanco S.A., 2017, Brazilian Sovereign Fixed Income and Foreign Exchange Markets - Handbook (First Edition).
#'
#' @keywords datasets
#'
"NonBusDays.Brazil"
